* ------------------------------------------------------------------------
* ------------------------------------------------------------------------
* SISTEMA.......: TUTIFRUTI
* PROGRAMA......: TutiDeta.prg
* AUTOR.........: EDUARDO V. FLORES RIVAS
* FECHA.........: 22/05/2014
* ACTUALIZADO...:
* COMENTARIOS...: VENTA DE DETALLE PARA FACTURAS
* ------------------------------------------------------------------------
* ------------------------------------------------------------------------

PROC DetaTuti

   IF IsWindowDefined(Win_DetaTuti) = .T.
      MINIMIZE WINDOW Win_DetaTuti
      RESTORE WINDOW Win_DetaTuti
      RETURN
   ENDIF

   DEFINE WINDOW Win_DetaTuti ;
      AT 0,0 ;
      WIDTH 1010 ;
      HEIGHT 210 ;
      TITLE 'Detalles' ;
      MODAL ;
      FONT 'ARIAL' SIZE 10 ;
      ON INIT DetaTutiInicia() ;
      ON RELEASE DetaTutiCerrar()
//
//
//
      DEFINE TIMER Timer_2 ;
      INTERVAL 4000  ;
      ACTION DetaTutiScan()
//
//
//
   @  010 , 010 LABEL LblLetra ;
      VALUE 'Letra' ;
      WIDTH  050 ;
      HEIGHT 030 ;
      BACKCOLOR Color_Label1_Back ;
      FONTCOLOR Color_Label1_Font ;
      CENTERALIGN

   @  010 , 070 LABEL LblNombre ;
      VALUE 'Nombre' ;
      WIDTH  120 ;
      HEIGHT 030 ;
      BACKCOLOR Color_Label1_Back ;
      FONTCOLOR Color_Label1_Font ;
      CENTERALIGN

   @  010 , 200 LABEL LblApellido ;
      VALUE 'Apellido' ;
      WIDTH  120 ;
      HEIGHT 030 ;
      BACKCOLOR Color_Label1_Back ;
      FONTCOLOR Color_Label1_Font ;
      CENTERALIGN

   @  010 , 330 LABEL LblAnimal ;
      VALUE 'Animal' ;
      WIDTH  120 ;
      HEIGHT 030 ;
      BACKCOLOR Color_Label1_Back ;
      FONTCOLOR Color_Label1_Font ;
      CENTERALIGN

   @  010 , 460 LABEL LblVegetal ;
      VALUE 'Vegetal' ;
      WIDTH  120 ;
      HEIGHT 030 ;
      BACKCOLOR Color_Label1_Back ;
      FONTCOLOR Color_Label1_Font ;
      CENTERALIGN

   @  010 , 590 LABEL LblObjeto ;
      VALUE 'Objeto' ;
      WIDTH  120 ;
      HEIGHT 030 ;
      BACKCOLOR Color_Label1_Back ;
      FONTCOLOR Color_Label1_Font ;
      CENTERALIGN

   @  010 , 720 LABEL LblPais ;
      VALUE 'Pais' ;
      WIDTH  120 ;
      HEIGHT 030 ;
      BACKCOLOR Color_Label1_Back ;
      FONTCOLOR Color_Label1_Font ;
      CENTERALIGN

   @  010 , 850 LABEL LblColor ;
      VALUE 'Color' ;
      WIDTH  120 ;
      HEIGHT 030 ;
      BACKCOLOR Color_Label1_Back ;
      FONTCOLOR Color_Label1_Font ;
      CENTERALIGN
//
//
//
   @  050 , 010 TEXTBOX TxtLetra ;
      WIDTH  050 ;
      HEIGHT 030 ;
      READONLY

   @  050 , 070 TEXTBOX TxtNombre ;
      WIDTH  120 ;
      HEIGHT 030 ;
      UPPER ;
      ON LOSTFOCUS DetaTutiNom() ;
      ON ENTER DetaTutiNom()

   @  050 , 200 TEXTBOX TxtApellido ;
      WIDTH  120 ;
      HEIGHT 030 ;
      UPPER ;
      ON LOSTFOCUS DetaTutiApe() ;
      ON ENTER DetaTutiApe()

   @  050 , 330 TEXTBOX TxtAnimal ;
      WIDTH  120 ;
      HEIGHT 030 ;
      UPPER ;
      ON LOSTFOCUS DetaTutiAni() ;
      ON ENTER DetaTutiAni()

   @  050 , 460 TEXTBOX TxtVegetal ;
      WIDTH  120 ;
      HEIGHT 030 ;
      UPPER ;
      ON LOSTFOCUS DetaTutiVeg() ;
      ON ENTER DetaTutiVeg()

   @  050 , 590 TEXTBOX TxtObjeto ;
      WIDTH  120 ;
      HEIGHT 030 ;
      UPPER ;
      ON LOSTFOCUS DetaTutiObj() ;
      ON ENTER DetaTutiObj()

   @  050 , 720 TEXTBOX TxtPais ;
      WIDTH  120 ;
      HEIGHT 030 ;
      UPPER ;
      ON LOSTFOCUS DetaTutiPai() ;
      ON ENTER DetaTutiPai()

   @  050 , 850 TEXTBOX TxtColor ;
      WIDTH  120 ;
      HEIGHT 030 ;
      UPPER ;
      ON LOSTFOCUS DetaTutiCol() ;
      ON ENTER DetaTutiCol()
//
//
//
   @  090 , 460 BUTTON BotStop ;
      CAPTION "STOP" ;
      PICTURE "imagen\alto.bmp" ;
      ACTION DetaTutiStop() ;
      LEFT ;
      WIDTH 110 ;
      HEIGHT 60

   END WINDOW

   CENTER WINDOW Win_DetaTuti
   ACTIVATE WINDOW Win_DetaTuti

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC DetaTutiInicia()

LOCAL nJugada := ''
LOCAL cNueva  := aLetras[1]

   SELE XJUGA
   LOCATE FOR XJUGA->JUGADOR = PLAYERNAME
   cLetra1 := XJUGA->LETRA1
   cLetra2 := XJUGA->LETRA2

   IF cLetra1 = ' '
      PLAYLETRA := cNueva
   ELSE
      IF cLetra1 = cLetra2
         nJugada   := ASCAN( aLetras , cLetra1 )
         cNueva    := aLetras[nJugada+1]
         PLAYLETRA := cNueva
      ELSE
         PLAYLETRA := cLetra1
      ENDIF
   ENDIF

   Win_DetaTuti.TxtLetra.Value := PLAYLETRA

   SELE XJUGA
   LOCATE FOR XJUGA->JUGADOR = PLAYERNAME
   IF RED_RLOCK()
      XJUGA->LETRA1 := PLAYLETRA
      RED_UNLOCK()
   ENDIF

   SELE XTUTI
   LOCATE FOR XTUTI->JUGADOR = PLAYERNAME .AND. XTUTI->LETRA = PLAYLETRA
   IF ! FOUND()
      IF RED_APPE()
         XTUTI->LETRA    := PLAYLETRA
         XTUTI->JUGADOR  := PLAYERNAME
         RED_UNLOCK()
      ENDIF
   ELSE
      Win_DetaTuti.TxtNombre.Value   := XTUTI->NOMBRE
      Win_DetaTuti.TxtApellido.Value := XTUTI->APELLIDO
      Win_DetaTuti.TxtAnimal.Value   := XTUTI->ANIMAL
      Win_DetaTuti.TxtVegetal.Value  := XTUTI->VEGETAL
      Win_DetaTuti.TxtObjeto.Value   := XTUTI->OBJETO
      Win_DetaTuti.TxtPais.Value     := XTUTI->PAIS
      Win_DetaTuti.TxtColor.Value    := XTUTI->COLOR
   ENDIF

   Win_DetaTuti.TxtNombre.SetFocus

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC DetaTutiCerrar()

   Win_DetaTuti.Timer_2.Enabled := .F.

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC DetaTutiNom

   SELE XTUTI
   LOCATE FOR XTUTI->LETRA = PLAYLETRA .AND. XTUTI->JUGADOR = PLAYERNAME
   IF RED_RLOCK()
      XTUTI->NOMBRE   := Win_DetaTuti.TxtNombre.Value
      RED_UNLOCK()
   ENDIF

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC DetaTutiApe

   SELE XTUTI
   LOCATE FOR XTUTI->LETRA = PLAYLETRA .AND. XTUTI->JUGADOR = PLAYERNAME
   IF RED_RLOCK()
      XTUTI->APELLIDO := Win_DetaTuti.TxtApellido.Value
      RED_UNLOCK()
   ENDIF

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC DetaTutiAni

   SELE XTUTI
   LOCATE FOR XTUTI->LETRA = PLAYLETRA .AND. XTUTI->JUGADOR = PLAYERNAME
   IF RED_RLOCK()
      XTUTI->ANIMAL   := Win_DetaTuti.TxtAnimal.Value
      RED_UNLOCK()
   ENDIF

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC DetaTutiVeg

   SELE XTUTI
   LOCATE FOR XTUTI->LETRA = PLAYLETRA .AND. XTUTI->JUGADOR = PLAYERNAME
   IF RED_RLOCK()
      XTUTI->VEGETAL  := Win_DetaTuti.TxtVegetal.Value
      RED_UNLOCK()
   ENDIF

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC DetaTutiObj

   SELE XTUTI
   LOCATE FOR XTUTI->LETRA = PLAYLETRA .AND. XTUTI->JUGADOR = PLAYERNAME
   IF RED_RLOCK()
      XTUTI->OBJETO   := Win_DetaTuti.TxtObjeto.Value
      RED_UNLOCK()
   ENDIF

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC DetaTutiPai

   SELE XTUTI
   LOCATE FOR XTUTI->LETRA = PLAYLETRA .AND. XTUTI->JUGADOR = PLAYERNAME
   IF RED_RLOCK()
      XTUTI->PAIS     := Win_DetaTuti.TxtPais.Value
      RED_UNLOCK()
   ENDIF

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC DetaTutiCol

   SELE XTUTI
   LOCATE FOR XTUTI->LETRA = PLAYLETRA .AND. XTUTI->JUGADOR = PLAYERNAME
   IF RED_RLOCK()
      XTUTI->COLOR    := Win_DetaTuti.TxtColor.Value
      RED_UNLOCK()
   ENDIF

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC DetaTutiScan()

   SELE XJUGA
   DBGOTOP()
   DO WHILE .NOT. XJUGA->(EOF())
      IF XJUGA->ESTADO = 2
         PLAYSTATUS := 2
         Win_DetaTuti.Release
         EXIT
      ENDIF
      SKIP
   ENDDO

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC DetaTutiStop()

   Win_DetaTuti.Timer_2.Enabled := .F.

   IF LENNOSPC(Win_DetaTuti.TxtNombre.Value) < 3
      MsgInfo('Tramposo(a) te falta el nombre.')
      Win_DetaTuti.TxtNombre.Setfocus
      RETURN
   ENDIF

   IF LENNOSPC(Win_DetaTuti.TxtApellido.Value) < 3
      MsgInfo('Tramposo(a) te falta el apellido.')
      Win_DetaTuti.TxtApellido.Setfocus
      RETURN
   ENDIF

   IF LENNOSPC(Win_DetaTuti.TxtAnimal.Value) < 3
      MsgInfo('Tramposo(a) te falta el animal.')
      Win_DetaTuti.TxtAnimal.Setfocus
      RETURN
   ENDIF

   IF LENNOSPC(Win_DetaTuti.TxtVegetal.Value) < 3
      MsgInfo('Tramposo(a) te falta el vegetal.')
      Win_DetaTuti.TxtVegetal.Setfocus
      RETURN
   ENDIF

   IF LENNOSPC(Win_DetaTuti.TxtObjeto.Value) < 3
      MsgInfo('Tramposo(a) te falta el objeto.')
      Win_DetaTuti.TxtObjeto.Setfocus
      RETURN
   ENDIF

   IF LENNOSPC(Win_DetaTuti.TxtPais.Value) < 3
      MsgInfo('Tramposo(a) te falta el pais.')
      Win_DetaTuti.TxtPais.Setfocus
      RETURN
   ENDIF

   IF LENNOSPC(Win_DetaTuti.TxtColor.Value) < 3
      MsgInfo('Tramposo(a) te falta el color.')
      Win_DetaTuti.TxtColor.Setfocus
      RETURN
   ENDIF

   PLAYSTATUS   := 2
   TutiEstados(2) // Pasa a todos los jugadores al estado STOP.

   Win_DetaTuti.Release

RETURN