* ------------------------------------------------------ *
* SISTEMA     : TUTIFRUTI                                *
* PRG         : DIARIO.PRG                               *
* CREADO      : 15-12-2005                               *
* ACTUALIZADO : 24-04-2006                               *
* AUTOR       : EDUARDO V. FLORES RIVAS                  *
* COMENTARIOS : PRG PARA INGRESO DE COMPRAS.             *
* ------------------------------------------------------ *

#include <minigui.ch>

FUNCTION MAIN

REQUEST DBFCDX
RDDSETDEFAULT("DBFCDX")

IF IsWindowDefined(Win_Tuti)=.T.
   MINIMIZE WINDOW Win_Tuti
   RESTORE WINDOW Win_Tuti
   RETURN
ENDIF

SET AUTOPEN    Off
SET BELL       Off
SET BROWSESYNC On
SET DATE TO BRIT
SET DELETED    On
SET EPOCH TO 1990
SET NAVIGATION EXTENDED
SET SAFETY     Off
SET SOFTSEEK   On
SET WRAP       On

PUBLIC Mi_Amarillo        := {255,255,192}
PUBLIC Mi_Verde_Nilo      := {160,192,192}
PUBLIC Mi_Verde_Claro     := {192,255,192}
PUBLIC Mi_Celeste_Suave   := {160,192,255}
PUBLIC Mi_Celeste_Claro   := {192,255,255}
PUBLIC Mi_Naranja         := {255,160,096}
PUBLIC Mi_Rosa_Oscuro     := {128,032,096}
PUBLIC Mi_Azul_Grisaceo   := {128,160,192}
PUBLIC Mi_Azul_Oscuro     := {032,032,128}

PUBLIC Color_Browse_Admin := Mi_Amarillo
PUBLIC Color_Browse_Help  := Mi_Amarillo
PUBLIC Color_Grid_Datos   := Mi_Celeste_Claro

PUBLIC Color_Label1_Font  := BLACK
PUBLIC Color_Label1_Back  := Mi_Naranja
PUBLIC Color_Dato1_Font   := YELLOW
PUBLIC Color_Dato1_Back   := Mi_Rosa_Oscuro

PUBLIC Color_Label2_Font  := BLACK
PUBLIC Color_Label2_Back  := Mi_Verde_Nilo
PUBLIC Color_Dato2_Font   := BLACK
PUBLIC Color_Dato2_Back   := Mi_Verde_Claro

PUBLIC Color_Label3_Font  := WHITE
PUBLIC Color_Label3_Back  := Mi_Azul_Oscuro
PUBLIC Color_Dato3_Font   := WHITE
PUBLIC Color_Dato3_Back   := Mi_Azul_Grisaceo

PUBLIC Color_Label4_Font  := BLACK
PUBLIC Color_Label4_Back  := Mi_Celeste_Claro
PUBLIC Color_Dato4_Font   := BLACK
PUBLIC Color_Dato4_Back   := Mi_Celeste_Suave

PUBLIC BrwL               := BROWSE_JTFY_LEFT
PUBLIC BrwC               := BROWSE_JTFY_CENTER
PUBLIC BrwR               := BROWSE_JTFY_RIGHT

PUBLIC PLAYERNAME         := ''
PUBLIC PLAYERSCORE        := 0
PUBLIC PLAYSTATUS         := 0
PUBLIC PLAYLETRA          := ''
PUBLIC PLAYERS            := 3
PUBLIC PLAYERMAC          := GetMac()

PUBLIC cPass := '\\serverfiles\publica\Modulos.{88C6C381-2E85-11d0-94DE-444553540000}\Tuti\' //<- cambiar carpeta compartida del juego
PUBLIC cTuti := cPass+'TUTI'+DTOS(DATE())
PUBLIC aTuti := {;
{'JUGADOR'  ,'C',30,0},;
{'LETRA'    ,'C', 1,0},;
{'Nombre'   ,'C',30,0},;
{'PNOM'     ,'N', 2,0},;
{'Apellido' ,'C',30,0},;
{'PAPE'     ,'N', 2,0},;
{'Animal'   ,'C',30,0},;
{'PANI'     ,'N', 2,0},;
{'Vegetal'  ,'C',30,0},;
{'PVEG'     ,'N', 2,0},;
{'Objeto'   ,'C',30,0},;
{'POBJ'     ,'N', 2,0},;
{'Pais'     ,'C',30,0},;
{'PPAI'     ,'N', 2,0},;
{'Color'    ,'C',30,0},;
{'PCOL'     ,'N', 2,0},;
{'PUNTOS'   ,'N', 4,0}}
PUBLIC cJuga := cPass+'JUGADORES'
PUBLIC aJuga := {;
{'PC'       ,'C',17,0},;
{'JUGADOR'  ,'C',30,0},;
{'PUNTOS'   ,'N', 4,0},;
{'LETRA1'   ,'C', 1,0},;
{'LETRA2'   ,'C', 1,0},;
{'ESTADO'   ,'N', 1,0}}
PUBLIC cConf := cPass+'CONFIG'
PUBLIC aConf := {;
{'VARIABLE' ,'C',20,0},;
{'VALOR'    ,'C',30,0}}
PUBLIC aLetras := {'U','C','K','E','I','J','R','G','T','Q','W','M','H','L','Y','N','Z','B','X','O','A','F','P','D','S','V'}

DEFINE WINDOW Win_Tuti ;
   AT 0 , 0 ;
   WIDTH 1010 HEIGHT 730 ;
   TITLE "Tuti" ;
   FONT "Arial" SIZE 9 ;
   MAIN ;
   ON INIT TutiIniciar() ;
   ON RELEASE TutiSalir()

      DEFINE TIMER Timer_1 ;
      INTERVAL 4000  ;
      ACTION TutiScanear()

      DEFINE TOOLBAR CobraBarra BUTTONSIZE 60,60 FLAT BORDER

      BUTTON Listo     ;
         CAPTION '&Listo'  ;
         PICTURE 'imagen\listo.bmp'   ;
         ACTION TutiListo()

      BUTTON Salir     ;
         CAPTION '&Salir'   ;
         PICTURE 'imagen\salir.bmp' ;
         ACTION Win_Tuti.Release

      END TOOLBAR
//
//
//

      ON KEY CONTROL+R ACTION Revision()
      ON KEY CONTROL+T ACTION TutiRefrescaScore()
      ON KEY CONTROL+L ACTION TutiEstados(1)
      ON KEY CONTROL+O ACTION TutiEstados(0)
      ON KEY CONTROL+J ACTION TutiJugadores()
//      ON KEY CONTROL+X ACTION TutiLimpiaJugadores()

//
//
//
      @ 080 , 010 BROWSE BrwTuti ;
      WIDTH  980 ;
      HEIGHT 400 ;
      HEADERS { 'LETRA'  , 'JUGADOR' , 'Nombre' , 'Apellido' , 'Animal' , 'Vegetal' , 'Objeto' , 'Pais' , 'Color' , 'PUNTOS' } ;
      FIELDS  { 'LETRA'  , 'JUGADOR' , 'NOMBRE' , 'APELLIDO' , 'ANIMAL' , 'VEGETAL' , 'OBJETO' , 'PAIS' , 'COLOR' , 'PUNTOS' } ;
      WIDTHS  { 060      , 100       , 100      , 100        , 100      , 100       , 100      , 100    , 100     , 080      } ;
      JUSTIFY { BrwC     , BrwC      , BrwC     , BrwC       , BrwC     , BrwC      , BrwC     , BrwC   , BrwC    , BrwC     } ;
      WORKAREA XTUTI
//
//
//
      @ 490 , 010 BROWSE BrwJuga ;
      WIDTH  470 ;
      HEIGHT 200 ;
      HEADERS { 'Jugador'  , 'Puntos' , 'Estado'         } ;
      FIELDS  { 'JUGADOR'  , 'PUNTOS' , 'NUMEST(ESTADO)' } ;
      WIDTHS  { 200        , 100      , 100              } ;
      JUSTIFY { BrwL       , BrwC     , BrwC             } ;
      WORKAREA XJUGA

END WINDOW

   CENTER WINDOW Win_Tuti
   ACTIVATE WINDOW Win_Tuti


RETURN


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

PROC TutiIniciar

LOCAL lclean  := .F.
LOCAL aLetra1 := {'U','C','K','E','I','J','R','G','T','Q','W','M','H','L','Y','N','Z','B','X','O','A','F','P','D','S','V'}
LOCAL aLetra2 := {'I','Q','Y','N','Z','B','X','O','W','M','H','L','U','C','K','E','A','F','P','D','S','V','J','R','G','T'}
LOCAL aLetra3 := {'B','I','Q','Y','N','Z','L','U','C','F','P','D','S','V','J','R','K','E','A','G','T','X','O','W','M','H'}
LOCAL aLetra4 := {'N','Z','L','U','C','F','P','D','S','B','I','Q','Y','E','A','G','T','X','O','W','M','H','V','J','R','K'}
LOCAL aLetra5 := {'F','P','D','S','B','T','X','I','Q','N','Z','G','O','W','M','H','V','L','U','C','J','R','K','Y','E','A'}
LOCAL aLetra6 := {'T','X','F','P','D','S','E','M','H','V','R','K','A','J','Y','B','G','W','I','Q','Z','N','L','U','C','O'}
LOCAL aLetra7 := {'S','E','M','J','Y','B','G','H','V','R','N','O','L','K','Z','Q','C','U','A','F','P','D','W','I','T','X'}
LOCAL aLetra8 := {'G','H','V','R','Q','C','U','A','N','T','O','L','X','K','W','I','Z','S','E','M','J','Y','B','F','P','D'}
LOCAL aLetra9 := {'V','R','Q','G','H','A','N','E','M','Y','P','D','B','T','I','Z','O','L','X','K','C','U','W','S','J','F'}
LOCAL aLetra0 := {'M','Q','G','H','S','A','P','B','Z','I','F','W','Y','V','L','J','N','R','E','D','T','O','X','K','C','U'}
LOCAL nSet    := VAL( RIGHT( STRZERO( DAY( DATE() ) , 2 ) , 1 ) )

   DO CASE
      CASE nSet = 1
         aLetras := aLetra1
      CASE nSet = 2
         aLetras := aLetra2
      CASE nSet = 3
         aLetras := aLetra3
      CASE nSet = 4
         aLetras := aLetra4
      CASE nSet = 5
         aLetras := aLetra5
      CASE nSet = 6
         aLetras := aLetra6
      CASE nSet = 7
         aLetras := aLetra7
      CASE nSet = 8
         aLetras := aLetra8
      CASE nSet = 9
         aLetras := aLetra9
      CASE nSet = 0
         aLetras := aLetra0
   ENDCASE

   IF ! FILE(cJuga+'.DBF')
      DBCREATE( cJuga , aJuga )
   ENDIF

   IF ! FILE(cTuti+'.DBF')
      DBCREATE( cTuti , aTuti )
      lclean := .T.
   ENDIF

   SELE 0
   USE &cConf ALIAS XCONF SHARED VIA 'DBFCDX'

   SELE 0
   USE &cTuti ALIAS XTUTI SHARED VIA 'DBFCDX'

   SELE 0
   USE &cJuga ALIAS XJUGA SHARED VIA 'DBFCDX'
   LOCATE FOR PC = PLAYERMAC
   IF ! FOUND()
      DO WHILE .T.
         cJugador := INPUTBOX('Jugador:')
         IF ! EMPTY(cJugador)
            IF RED_APPE()
               XJUGA->PC      := PLAYERMAC
               XJUGA->JUGADOR := cJugador
               RED_UNLOCK()
               DBGOTOP()
               Win_Tuti.BrwJuga.Value := XJUGA->(RECNO())
               Win_Tuti.BrwJuga.Refresh
               EXIT
            ENDIF
         ENDIF
      ENDDO
   ENDIF

   IF lclean
      TutiLimpiaJugadores()
   ENDIF

   SELE XJUGA
   LOCATE FOR PC = PLAYERMAC
   PLAYERNAME  := XJUGA->JUGADOR
   PLAYERSCORE := XJUGA->PUNTOS

   SELE XTUTI

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC TutiSalir()

LOCAL lSalir := .F.

   Win_Tuti.Timer_1.Enabled := .F.
   IF PLAYSTATUS = 1
      IF MsgYesNo(' AL SALIR PERDERAS LA PARTIDA - DESEAS SALIR ?')
         lSalir := .T.
      ENDIF
   ELSE
      lSalir := .T.
   ENDIF

RETURN


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

PROC TutiListo

   IF PLAYSTATUS = 0
      SELE XJUGA
      LOCATE FOR XJUGA->JUGADOR = PLAYERNAME
      IF FOUND()
         IF RED_RLOCK()
            XJUGA->ESTADO := 1
            RED_UNLOCK()
         ENDIF
      ENDIF
      DBGOTOP()
      Win_Tuti.BrwJuga.Value := XJUGA->(RECNO())
      Win_Tuti.BrwJuga.Refresh
      Win_Tuti.Timer_1.Enabled := .T.
   ENDIF

RETURN


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

PROC TutiScanear

LOCAL nTotalPlayers := 0
LOCAL nCount        := 0

   Win_Tuti.Timer_1.Enabled := .F.

   SELE XCONF
   DBGOTO(1)
   PLAYERS := VAL(XCONF->VALOR)

   nTotalTuti    := XTUTI->(RECCOUNT())
   nTotalPlayers := PLAYERS  //XJUGA->(RECCOUNT())

   IF nTotalPlayers = PLAYERS

      DO CASE

         CASE PLAYSTATUS = 0 // ESPERANDO

            SELE XJUGA
            DBGOTOP()
            DO WHILE .NOT. XJUGA->(EOF())
               IF XJUGA->ESTADO = 1
                  nCount++
               ENDIF
               SKIP
            ENDDO
            IF nCount >= nTotalPlayers
               PLAYSTATUS := 1
               Win_Tuti.Timer_1.Enabled := .F.
               DetaTuti()
               Win_Tuti.Timer_1.Enabled := .T.
            ENDIF
            DBGOTOP()
            Win_Tuti.BrwJuga.Value := XJUGA->(RECNO())
            Win_Tuti.BrwJuga.Refresh

         CASE PLAYSTATUS = 1 // JUGANDO

            SELE XJUGA
            DBGOTOP()
            DO WHILE .NOT. XJUGA->(EOF())
               IF XJUGA->ESTADO = 2
                  PLAYSTATUS := 2
                  IF IsWindowDefined(Win_DetaTuti) = .T.
                     RELEASE WINDOW Win_DetaTuti
                  ENDIF
                  EXIT
               ENDIF
               SKIP
            ENDDO

         CASE PLAYSTATUS = 2 // STOPEADOS

            SELE XJUGA
            DBGOTOP()
            DO WHILE .NOT. XJUGA->(EOF())
               IF XJUGA->ESTADO = 0
                  nCount++
               ENDIF
               SKIP
            ENDDO
            IF nCount >= nTotalPlayers
               PLAYSTATUS := 0
            ENDIF
            TutiRefrescaScore()

      ENDCASE

   ENDIF

   Win_Tuti.Timer_1.Enabled := .T.
   SELE XTUTI

RETURN


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC NUMEST( nNumero )

LOCAL cEstado := '...'

   DO CASE
      CASE nNumero = 1
         cEstado := 'LISTO'
      CASE nNumero = 2
         cEstado := 'STOP'
   ENDCASE

RETURN( cEstado )


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

PROC TutiEstados( nEstado )

   SELE XJUGA
   DBGOTOP()
   DO WHILE .NOT. XJUGA->(EOF())
      IF RED_RLOCK()
         REPLACE XJUGA->ESTADO WITH nEstado   // 0 = Espera , 1 = Listo , 2 = Stopped
         RED_UNLOCK()
      ENDIF
      SKIP
   ENDDO

RETURN


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

PROC TutiLetras( cLetra )

   SELE XJUGA
   DBGOTOP()
   DO WHILE .NOT. XJUGA->(EOF())
      IF RED_RLOCK()
         REPLACE XJUGA->LETRA2 WITH XJUGA->LETRA1
         RED_UNLOCK()
      ENDIF
      SKIP
   ENDDO

RETURN


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

PROC TutiLimpiaJugadores

   SELE XJUGA
   DBGOTOP()
   DO WHILE .NOT. XJUGA->(EOF())
      IF XJUGA->PUNTOS > 0
         IF RED_RLOCK()
            XJUGA->ESTADO := 0
            XJUGA->PUNTOS := 0
            XJUGA->LETRA1 := ' '
            XJUGA->LETRA2 := ' '
            RED_UNLOCK()
            SKIP
         ENDIF
      ELSE
         SKIP
      ENDIF
   ENDDO
   DBGOTOP()

RETURN


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

PROC TutiRefrescaScore

   SELE XJUGA
   DBGOTOP()
   DO WHILE .NOT. XJUGA->(EOF())
      IF RED_RLOCK()
         REPLACE PUNTOS WITH 0
         RED_UNLOCK()
      ENDIF
      SKIP
   ENDDO

   RevisionPuntajear()

   SELE XTUTI
   DBGOTOP()
   DO WHILE .NOT. XTUTI->(EOF())
      SELE XJUGA
      LOCATE FOR XJUGA->JUGADOR = XTUTI->JUGADOR
      IF FOUND()
         IF RED_RLOCK()
            XJUGA->PUNTOS := XJUGA->PUNTOS + XTUTI->PUNTOS
            RED_UNLOCK()
         ENDIF
      ENDIF
      SELE XTUTI
      SKIP
   ENDDO

   SELE XJUGA
   DBGOTOP()
   Win_Tuti.BrwJuga.Value := XJUGA->(RECNO())
   Win_Tuti.BrwJuga.Refresh
   SELE XTUTI
   DBGOTOP()
   Win_Tuti.BrwTuti.Value := XTUTI->(RECNO())
   Win_Tuti.BrwTuti.Refresh

RETURN


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

PROC TutiJugadores

LOCAL cJugadores := INPUTBOX('Jugadores:')

   IF ! EMPTY(cJugadores)
      IF VAL(cJugadores) > 0
         PLAYERS := VAL(cJugadores)
         SELE XCONF
         DBGOTO(1)
         IF RED_RLOCK()
            XCONF->VALOR := cJugadores
            RED_UNLOCK()
         ENDIF
      ENDIF
   ENDIF

RETURN


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC GetMac

Local oLocator
Local oNetworkAdapter
Local oAdapter
Local nI                   := 0
Local nTemp                := 0
Local cMAC                 := ' '

oLocator        := win_oleCreateObject( "wbemScripting.SwbemLocator" )
oNetworkAdapter := oLocator:ConnectServer()

   for each oAdapter in oNetworkAdapter:ExecQuery("SELECT * FROM Win32_NetworkAdapter WHERE Manufacturer != 'Microsoft' AND NOT PNPDeviceID LIKE 'ROOT\\%'")
     If ! empty( oAdapter:MACAddress )
        ++nI
        nTemp := oAdapter:NetConnectionStatus
        IF nTemp + 1 = 3
           cMAC := oAdapter:MACAddress
           EXIT
        ENDIF
     Endif
   next

oLocator := Nil
oAdapter := Nil

Return( cMAC )

#include "TutiDeta.prg"
#include "TutiRevisa.prg"

#include "FUNCION.prg"
#include "USERED.prg"