* ------------------------------------------------------------------------
* ------------------------------------------------------------------------
* SISTEMA.......: TUTIFRUTI
* PROGRAMA......: TutiRevisa.prg
* AUTOR.........: EDUARDO V. FLORES RIVAS
* FECHA.........: 22/05/2014
* ACTUALIZADO...:
* COMENTARIOS...: REVISAR FICHAS DE JUGADORES.
* ------------------------------------------------------------------------
* ------------------------------------------------------------------------

PROC Revision

   IF IsWindowDefined(Win_Revision) = .T.
      MINIMIZE WINDOW Win_Revision
      RESTORE WINDOW Win_Revision
      RETURN
   ENDIF

   Win_Tuti.Timer_1.Enabled := .F.

   SELE XTUTI
   SET FILTER TO
   SET FILTER TO XTUTI->LETRA = PLAYLETRA
   DBGOTOP()

   DEFINE WINDOW Win_Revision ;
      AT 0,0 ;
      WIDTH 1020 ;
      HEIGHT 680 ;
      TITLE 'Tuti' ;
      MODAL ;
      ON INIT RevisionIniciar() ;
      FONT 'ARIAL' SIZE 8
//
//
//
      @ 010 , 010 BROWSE BrwRevi ;
      WIDTH  1000 ;
      HEIGHT 500 ;
      HEADERS  { 'JUGADOR', 'Nombre' , 'pN'   , 'Apellido' , 'pA'   , 'Animal' , 'pN'   , 'Vegetal' , 'pV'   , 'Objeto' , 'pO'   , 'Pais' , 'pP'   , 'Color' , 'pC'   , 'PUNTOS' } ;
      FIELDS   { 'JUGADOR', 'NOMBRE' , 'PNOM' , 'APELLIDO' , 'PAPE' , 'ANIMAL' , 'PANI' , 'VEGETAL' , 'PVEG' , 'OBJETO' , 'POBJ' , 'PAIS' , 'PPAI' , 'COLOR' , 'PCOL' , 'PUNTOS' } ;
      WIDTHS   { 080      , 100      , 040    , 100        , 040    , 100      , 040    , 100       , 040    , 100      , 040    , 100    , 040    , 100     , 040    , 100      } ;
      JUSTIFY  { BrwC     , BrwC     , BrwC   , BrwC       , BrwC   , BrwC     , BrwC   , BrwC      , BrwC   , BrwC     , BrwC   , BrwC   , BrwC   , BrwC    , BrwC   , BrwC     } ;
      WORKAREA XTUTI ;
      EDIT ;
      LOCK ;
      READONLY { .T.      , .T.      , .F.    , .T.        , .F.    , .T.      , .F.    , .T.       , .F.    , .T.      , .F.    , .T.    , .F.    , .T.     , .F.    , .T.      }

      @ 530 , 010 BUTTON BotAceptar ;
      PICTURE "imagen\ok.bmp" ;
      ACTION RevisionAceptar() ;
      WIDTH 60 ;
      HEIGHT 60

   END WINDOW

   CENTER WINDOW Win_Revision
   ACTIVATE WINDOW Win_Revision

   SELE XTUTI
   SET FILTER TO
   DBGOTOP()
   Win_Tuti.Timer_1.Enabled := .T.

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC RevisionIniciar

LOCAL aCats := {'NOMBRE','APELLIDO','ANIMAL','VEGETAL','OBJETO','PAIS','COLOR'}
LOCAL aPnts := {'PNOM'  ,'PAPE'    ,'PANI'  ,'PVEG'   ,'POBJ'  ,'PPAI','PCOL' }
LOCAL nPunt := 0

   SELE XTUTI
   FOR nCat = 1 TO LEN(aCats)

      aCatX := {}
      DBGOTOP()
      DO WHILE .NOT. XTUTI->(EOF())
         cCat := aCats[nCat]
         pCat := aPnts[nCat]
         vCat := &cCat
         IF LENNOSPC(vCat) > 0
            IF LEFT(vCat,1) == PLAYLETRA
               AADD(aCatX,vCat)
               IF RED_RLOCK()
                  REPLACE &pCat WITH 10
                  RED_UNLOCK()
               ENDIF
            ENDIF
         ENDIF
         SKIP
      ENDDO

//    IDENTIFICAR REPETIDOS
      aMemX := {}
      aRepX := {}
      FOR nValX = 1 TO LEN(aCatX)
         nScan := ASCAN( aMemX , aCatX[nValX] )
         IF nScan = 0
            AADD( aMemX , aCatX[nValX] )
         ELSE
            AADD( aRepX , aCatX[nValX] )
         ENDIF
      NEXT

//    REDUCIR PUNTAJE DE REPETIDOS
      DBGOTOP()
      DO WHILE .NOT. XTUTI->(EOF())
         cCat := aCats[nCat]
         pCat := aPnts[nCat]
         vCat := &cCat
         IF LENNOSPC(vCat) > 0
            nScan := ASCAN( aRepX , vCat )
            IF nScan > 0
               IF RED_RLOCK()
                  REPLACE &pCat WITH 5
                  RED_UNLOCK()
               ENDIF
            ENDIF
         ENDIF
         SKIP
      ENDDO

   NEXT

   RevisionPuntajear()

   SELE XTUTI
   DBGOTOP()
   Win_Revision.BrwRevi.Value := XTUTI->(RECNO())
   Win_Revision.BrwRevi.Refresh

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC RevisionPuntajear

LOCAL nPlayPunt := 0
LOCAL aPnts := {'PNOM','PAPE','PANI','PVEG','POBJ','PPAI','PCOL' }

// CALCULAR PUNTAJE TOTAL POR JUGADOR
   SELE XTUTI
   DBGOTOP()
   DO WHILE .NOT. XTUTI->(EOF())
      nPlayPunt := 0
      FOR nPnt = 1 TO LEN(aPnts)
         pCat := aPnts[nPnt]
         pVal := &pCat
         nPlayPunt := nPlayPunt + pVal
      NEXT
      IF RED_RLOCK()
         REPLACE PUNTOS WITH nPlayPunt
         RED_UNLOCK()
      ENDIF
      SKIP
   ENDDO

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC RevisionAceptar

   RevisionPuntajear()
   TutiEstados(0)
   TutiLetras( PLAYLETRA )
   PLAYSTATUS := 0
   TutiRefrescaScore()
   Win_Revision.Release

RETURN